<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h2>#{messages['net.ihe.gazelle.atna.AvailableTestCases']}</h2>

        <h:form id="adminActionsForm">
            <!--<s:token allowMultiplePosts="true"/>-->
            <h:panelGroup rendered="#{s:hasRole('admin_role')}">
                <p>
                    <h:commandButton value="#{messages['net.ihe.gazelle.atna.CreateANewTestCase']}"
                                     action="#{testCaseListManager.navigateNewTestCase()}" styleClass="gzl-btn"/>
                </p>
            </h:panelGroup>
        </h:form>

        <h:form id="browserform">
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{testCaseListManager.filter.urlParameters}"/>
            <script>
                updateUrl("browserform:filterUrlParameters");
                jq162("#browserform\\:filterUrlParameters").bind('change',
                        function () {
                            updateUrl("browserform:filterUrlParameters");
                        });
            </script>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>

            <ui:decorate template="/layout/panels/_panel_filter_criteria.xhtml">
                <div class="form-horizontal">
                    <div class="row">
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{testCaseListManager.filter}"/>
                                <ui:param name="filterId" value="testCaseName"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.Name']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{testCaseListManager.filter}"/>
                                <ui:param name="filterId" value="context"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.Context']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                        </div>
                        <div class="col-md-6">
                            <ui:include src="/filter/filter.xhtml">
                                <ui:param name="filter" value="#{testCaseListManager.filter}"/>
                                <ui:param name="filterId" value="sut"/>
                                <ui:param name="filterName" value="#{messages['net.ihe.gazelle.atna.SUT']}"/>
                                <ui:param name="filterForm" value="browserform"/>
                            </ui:include>
                        </div>
                    </div>
                </div>
                <ui:define name="filter_buttons">
                    <a4j:commandLink title="#{messages['net.ihe.gazelle.atna.ResetCriteria']}"
                                     actionListener="#{testCaseListManager.reset()}" render="browserform">
                        <span class="fa fa-times-circle"></span>
                    </a4j:commandLink>
                </ui:define>
            </ui:decorate>

            #{dataTableStateHolder.setAscendingOn('name')}
            <rich:dataTable id="testCaseTable" value="#{testCaseListManager.testCases}" var="testCase"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}" render="testCaseDS">

                <g:column sortBy="#{'name'}" sortOrder="#{dataTableStateHolder.sortOrders['name']}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Name']}"/>
                    </ui:define>
                    <h:outputText value="#{testCase.name}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Context']}"/>
                    </ui:define>
                    <h:outputText value="#{testCase.context}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.SUT']}"/>
                    </ui:define>
                    <h:outputText value="#{testCase.sutType}"/>
                </g:column>
                <g:column>
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.Description']}"/>
                    </ui:define>
                    <h:outputText value="#{testCase.description}"/>
                </g:column>
                <g:column rendered="#{s:hasRole('admin_role')}">
                    <ui:define name="header">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.AllocatedSimulator']}"/>
                    </ui:define>
                    <h:outputLink value="#{testCaseListManager.linkToAllocatedSimulator(testCase.id)}">
                        <h:outputText value="#{testCase.getSimulatorKeyword()}"/>
                    </h:outputLink>
                </g:column>
                <g:column rendered="#{identity.loggedIn}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.atna.Actions']}</ui:define>

                    <div class="gzl-never-wrap">

                        <h:outputLink value="#{testCaseListManager.linkToViewTestCase(testCase.id)}"
                                      title="#{messages['net.ihe.gazelle.atna.View']}">
                            <s:span styleClass="fa fa-search"></s:span>
                        </h:outputLink>

                        <h:outputLink value="#{testCaseListManager.linkToRunTestCase(testCase.id)}"
                                      title="#{messages['net.ihe.gazelle.atna.Run']}">
                            <s:span styleClass="fa fa-play"></s:span>
                        </h:outputLink>

                        <h:outputLink value="#{testCaseListManager.linkToEditTestCase(testCase.id)}"
                                      title="#{messages['net.ihe.gazelle.atna.Edit']}"
                                      rendered="#{s:hasRole('admin_role')}">
                            <s:span styleClass="fa fa-pencil"></s:span>
                        </h:outputLink>

                        <a4j:commandLink action="#{testCaseListManager.setPendingTestCase(testCase)}"
                                         styleClass="text-danger"
                                         title="#{messages['net.ihe.gazelle.atna.DeleteTestCase']}"
                                         oncomplete="jq162('#deleteModal').modal('show');"
                                         rendered="#{s:hasRole('admin_role')}"
                                         render=" :deleteText">
                            <s:span styleClass="fa fa-trash-o"></s:span>
                        </a4j:commandLink>

                    </div>

                </g:column>

                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="testCaseDS"/>
                        <ui:param name="dataTableId" value="testCaseTable"/>
                    </ui:include>
                </f:facet>

            </rich:dataTable>

        </h:form>

        <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
            <ui:param name="popup_id" value="deleteModal"/>
            <ui:define name="popup_title"><span class="fa fa-exclamation-triangle"></span>#{messages['net.ihe.gazelle.questionnaire.Warning']}
            </ui:define>
            <s:div id="deleteText">
                <p>
                    <h:outputText
                            value="#{messages['net.ihe.gazelle.atna.YouAreAboutToDeleteTheTestCase']} #{testCaseListManager.pendingTestCase.name}. #{messages['net.ihe.gazelle.questionnaire.ThisCanNotBeUndone']}"/>
                </p>
                <p>
                    <h:outputText value="#{messages['net.ihe.gazelle.atna.TestCaseDeletionIsNotYetImplemented']}"/>
                </p>
            </s:div>
            <ui:define name="popup_footer">
                <h:form id="deleteForm">
                    <!--<s:token allowMultiplePosts="true"/>-->
                    <h:commandButton action="#{testCaseListManager.setPendingTestCase(null)}"
                                     oncomplete="jq162('#deleteModal').modal('hide');"
                                     value="#{messages['net.ihe.gazelle.atna.Cancel']}"
                                     styleClass="gzl-btn"/>
                    <a4j:commandButton action="#{testCaseListManager.setPendingTestCase(null)}"
                                       oncomplete="jq162('#deleteModal').modal('hide')"
                                       value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                       render="gazelle-messages,browserform"
                                       styleClass="gzl-btn-red" disabled="true"/>
                </h:form>
            </ui:define>
        </ui:decorate>

    </ui:define>
</ui:composition>
